package component
{
	import flash.events.MouseEvent;
	
	import mx.events.FlexEvent;
	
	import spark.components.Button;

	
	public class CustomButton extends Button
	{
		/**
		 * Constructor
		 * */
		public function CustomButton()
		{
			super();
		}
		
		//--------------------------------------------------------------------------
		//
		//  Properties
		//
		//--------------------------------------------------------------------------

		//----------------------------------
		//  clicked
		//----------------------------------
		/**
		 *  @private
		 *  Storage for the clicked property 
		 */
		private var _clicked:Boolean;
		
		public function get clicked():Boolean {
			return _clicked;
		}
		
		public function set clicked(value:Boolean):void {
			if (value == _clicked) {
				return;
			}
			_clicked = value;
			dispatchEvent(new FlexEvent(FlexEvent.VALUE_COMMIT));
			invalidateSkinState();
		}

		
		//--------------------------------------------------------------------------
		//
		//  States
		//
		//--------------------------------------------------------------------------
		
		/**
		 *  @private
		 */ 
		override protected function getCurrentSkinState():String {
			if (!clicked) {
				return super.getCurrentSkinState();
			} else {
				return "down";
			}	
		}
		
		/**
		 *  @private
		 */ 
		override protected function buttonReleased():void {
			super.buttonReleased();
			clicked = !clicked;
		}
			
	}
}